If Condition


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting If Condition
# 15  
Old 01-28-2011
ok.

This is the complete Command, which i would like to run, am i am running it in shell script, and that is the reason, i have used variables.

Code:
/opt/ldap/lgrep "ADD | MOD | DEL" /var/app/dir/slapd-ED/logs/access | /opt/ldap/lgrep -v "err=0 | err=50 | err=20 | err=65"]

Because I have several command, i put this is variables :
# Variables:
Code:
ED_Logs_Dir=/var/app/dir/slapd-ED/logs/acces
lgrep=/opt/ldap/lgrep
Access_OPS="\"ADD | MOD | DEL\""
Access_Err="\"err=0 | err=550 | err=20 | err=65\""
ED_CMD="$Access_OPS $ED_Logs_Dir/access | $lgrep -v $Access_Err"

#Command :
Code:
eval $lgrep $ED_CMD ; rslt=$? ; if [ "$rslt." = "0." ]; then echo "No Error"; fi



Output:

[28/Jan/2011:14:39:30 -0500] conn=1568702 op=15 msgId=52 - MOD dn="uid=acp10,ou=internal,ou=People,dc=eis,dc=xyz,dc=com"
[28/Jan/2011:14:39:30 -0500] conn=1568702 op=15 msgId=52 - RESULT err=50 tag=103 nentries=0 etime=0
No Error
# 16  
Old 01-28-2011
Code:
ED_Logs_Dir=/var/app/dir/slapd-ED/logs/acces #access has a typo
lgrep=/opt/ldap/lgrep
Access_OPS="\"ADD | MOD | DEL\""
Access_Err="\"err=0 | err=550 | err=20 | err=65\""
ED_CMD="$Access_OPS $ED_Logs_Dir/access | $lgrep -v $Access_Err" #the variable $ED_Logs_Dir already contains access so you don't need it here again

The reference to $ED_Logs_Dir in your last line expands to '/var/app/dir/slapd-ED/logs/acces/access' I'm sure that's unintended. So change your last line to
Code:
ED_CMD="$Access_OPS $ED_Logs_Dir | $lgrep -v $Access_Err"


Last edited by DC Slick; 01-28-2011 at 04:48 PM.. Reason: added code tags...
# 17  
Old 01-28-2011
There was a type, i have corrected it.

Also. there is separate variable : $Access_Err

Code:
ED_Logs_Dir=/var/app/dir/slapd-ED/logs
lgrep=/opt/ldap/lgrep
Access_OPS="\"ADD | MOD | DEL\""
Access_Err="\"err=0 | err=550 | err=20 | err=65\""
ED_CMD="$Access_OPS $ED_Logs_Dir/access | $lgrep -v $Access_Err"

If this command is complex, could you give me an example by illustrating simple command, and they i would try to emulate in this.
# 18  
Old 01-28-2011
(Possibly controversial post, it's getting late here).

What is the problem with just putting the entire command into a shell script? To my mind all the variables and eval are not needed because there is no variation posted.

Code:
#!/usr/bin/sh
/opt/ldap/lgrep "ADD | MOD | DEL" /var/app/dir/slapd-ED/logs/access | /opt/ldap/lgrep -v "err=0 | err=50 | err=20 | err=65"

This User Gave Thanks to methyl For This Post:
# 19  
Old 01-28-2011
I have something like 25 commands to put in the script, and and use variables in case it will be easier for others to update it.

Any i could use direct command.

Could you suggest on the error message?
# 20  
Old 01-28-2011
Please show examples, highlighting the command parameters which can change.
I would be surprised if the command itself is a variable. (Still trying to get rid of "eval").


Btw. Obfuscating the code does not make it easy for the next person.
# 21  
Old 01-28-2011
Let's get rid of mine command. Let's say for example:

Code:
grep -i "abc" filename.txt

What i want is, if i get the result, it should be displayed. If there are no results, i would like to display the message "No Output".

Could you please suggest me based on this simple example?

I appreciate your effort.

- John
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Help with if condition

o/p of my command is given below My requirement is if Pnumber is 0 then stabilization.Build.2013 else stabilization.PBuild.2013.3 (11 Replies)
Discussion started by: nikhil jain
11 Replies

2. UNIX for Dummies Questions & Answers

IF [ condition ] help

Hi all Unix newbie - please be gentle Am modifying an existing script to error trap a variable with a length of 0 #!/bin/bash ipfile='/var/data/bin/ipaddress' ] && ipold="$(< "$ipfile" )" ipnew="$( wget -q -O - checkip.dyndns.org | sed -e 's/.*Current IP Address: //;s/<.*$//' )" #... (6 Replies)
Discussion started by: CRChamberlain
6 Replies

3. Shell Programming and Scripting

If condition return 0 even when it fails to satisfy te condition

HI My doubt may be basic one but I need to get it clarified.. When i use "if" condition that checks for many AND, OR logical conditions like if ]; then return 0 fi Even the if condition fails it returns as zero.. Any clue.. But if i add else condition like if ]; ... (2 Replies)
Discussion started by: Priya Amaresh
2 Replies

4. Shell Programming and Scripting

if condition

if chr1:109457160 1 109457160 99.1735537190083 + chr1:109457233 1 109457233 99.1735537190083 - chr1:109457614 1 109457614 99.1735537190083 + chr1:109457618 1 109457618 100 + chr1:109457943 1 109457943 100 - chr1:109458224 1 109458224 99.1735537190083 - file1.txt If 6th column in... (3 Replies)
Discussion started by: johnkim0806
3 Replies

5. Shell Programming and Scripting

redirect stdout echo command in condition A run in condition B

hi, I have some problems in my simple script about the redirect echo stdout command inside a condition. Why is the echo command inside the elif still execute in the else command Here are my simple script After check on the two diff output the echo stdout redirect is present in two diff... (3 Replies)
Discussion started by: jao_madn
3 Replies

6. HP-UX

Difference between [condition] and [[condition]] and ((condition)) when used with if condition

Executed the following if conditions .. and got different results . only (( )) gave correct o/p with all scenarios . Can anybody please let me know what is the difference between and ] and ((condition)) when used with if condition. And why each condition gave different result. 1.... (2 Replies)
Discussion started by: soumyabubun
2 Replies

7. Shell Programming and Scripting

or in a IF condition

Hi I have to evaluate multiple conditions with an 'or'. Here is an example: if when i use the above i get a error message ' Please help me to know if i am missing something in the syntax. how do i achieve multiple "or" in the same if condition. Thanks. (11 Replies)
Discussion started by: sunrexstar
11 Replies

8. Shell Programming and Scripting

if..else condition

i have a paramter data_date in which i am passing a string value.i want to find out another paramter file_date from this.the logic is given below if day of data_date = sunday or monday then file_date=data_date-1 else file_date=data_date-2 i am passing data_date as 20061027. how can i... (3 Replies)
Discussion started by: dr46014
3 Replies

9. Shell Programming and Scripting

if condition

Hi friends, :) In a shell script i found the following if condition. echo -n "Which version of $1 do you want to restore ('0' to quit)? : " read desired if ${desired:=1} -ge $index ] ; then echo "$0: Restore canceled by user: index value too big." >&2 exit 1 fi Can... (1 Reply)
Discussion started by: ravi raj kumar
1 Replies

10. Shell Programming and Scripting

if condition ...

i have following if condition if above statement is case sensitive.....what is syntax if i have to make above comparision case insensetive (4 Replies)
Discussion started by: mahabunta
4 Replies
Login or Register to Ask a Question